"""
Bucketsort implementation using linked lists

Copyright 2020, University of Freiburg.

Philipp Schneider <philipp.schneider@cs.uni-freiburg.de>
"""

import math # noqa
import random # noqa
import time # noqa

from Queue import Queue # noqa

from ListElement import ListElement # noqa


def bucket_sort(array, k, key=lambda x: x):
    '''
    Implements the bucket sort algorithm to sort
        data elements using a key function to
        assign sorting keys to data elements

    Args:
        array: array of data elements
        k: largest key
        key: a function mapping data elements to values
        in range(k+1) (idendity function as default)
    
    >>> bucket_sort([210,121,203,420,307],2,lambda x: int(x / 10) % 10)
    [203, 307, 210, 121, 420]
    '''
    # add your code here


def bucket_sort_performance():
    for k in range(10**4, (5*(10**5))+1, 10**4):
        array = [random.randint(0, k) for i in range(10**4)]
        start_time = time.time()
        bucket_sort(array, k)
        run_time = (time.time() - start_time) * 1000
        print("%d\t%.1f" % (k, run_time))


if __name__ == "__main__":
    bucket_sort_performance()
